Subject: Re: [PATCH RFC net-next/mm V3 1/2] page_pool: Remove workqueue in new shutdown scheme

From: Jakub Kicinski <[email-masked]>
Date: Tue, 2 May 2023 19:33:09 -0700

On Fri, 28 Apr 2023 18:16:19 +0200 Jesper Dangaard Brouer wrote:
> This removes the workqueue scheme that periodically tests when
> inflight reach zero such that page_pool memory can be freed.
> 
> This change adds code to fast-path free checking for a shutdown flags
> bit after returning PP pages.

We can remove the warning without removing the entire delayed freeing
scheme. I definitely like the SHUTDOWN flag and patch 2 but I'm a bit
less clear on why the complexity of datapath freeing is justified.
Can you explain?

> Performance is very important for PP, as the fast path is used for
> XDP_DROP use-cases where NIC drivers recycle PP pages directly into PP
> alloc cache.
> 
> This patch (since V3) shows zero impact on this fast path. Micro
> benchmarked with [1] on Intel CPU E5-1650 @3.60GHz. The slight code
> reorg of likely() are deliberate.